'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _nextConfigProvider = require('../../next-config-provider/lib/index.js');

var _nextConfigProvider2 = _interopRequireDefault(_nextConfigProvider);

var _nextIcon = require('../../next-icon/lib/index.js');

var _nextIcon2 = _interopRequireDefault(_nextIcon);

var _nextUtil = require('../../next-util/lib/index.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** Collapse.Panel */
var Panel = (_temp = _class = function (_React$Component) {
    (0, _inherits3.default)(Panel, _React$Component);

    function Panel() {
        (0, _classCallCheck3.default)(this, Panel);
        return (0, _possibleConstructorReturn3.default)(this, _React$Component.apply(this, arguments));
    }

    //

    Panel.prototype.render = function render() {
        var _classNames;

        var _props = this.props,
            title = _props.title,
            children = _props.children,
            className = _props.className,
            isExpanded = _props.isExpanded,
            disabled = _props.disabled,
            style = _props.style,
            prefix = _props.prefix,
            onClick = _props.onClick,
            others = (0, _objectWithoutProperties3.default)(_props, ['title', 'children', 'className', 'isExpanded', 'disabled', 'style', 'prefix', 'onClick']);


        var cls = (0, _classnames2.default)((_classNames = {}, _classNames[prefix + 'collapse-panel'] = true, _classNames[prefix + 'collapse-panel-expanded'] = isExpanded, _classNames[prefix + 'collapse-panel-disabled'] = disabled, _classNames[className] = className, _classNames));

        return _react2.default.createElement(
            'div',
            (0, _extends3.default)({ className: cls, style: style }, others),
            _react2.default.createElement(
                'div',
                { className: prefix + 'collapse-panel-title', onClick: onClick },
                _react2.default.createElement(_nextIcon2.default, { type: 'arrow-up', className: prefix + 'collapse-panel-icon' }),
                title
            ),
            _react2.default.createElement(
                'div',
                { className: prefix + 'collapse-panel-content' },
                children
            )
        );
    };

    return Panel;
}(_react2.default.Component), _class.propTypes = {
    /**
     * 样式类名的品牌前缀
     */
    prefix: _propTypes2.default.string,
    /**
     * 子组件接受行内样式
     */
    style: _propTypes2.default.object,
    children: _propTypes2.default.any,
    isExpanded: _propTypes2.default.bool,
    /**
     * 是否禁止用户操作
     */
    disabled: _propTypes2.default.bool,
    /**
     * 标题
     */
    title: _propTypes2.default.node,
    /**
     * 扩展class
     */
    className: _propTypes2.default.string,
    onClick: _propTypes2.default.func
}, _class.defaultProps = {
    prefix: 'next-',
    isExpanded: false,
    onClick: _nextUtil.func.noop
}, _class.isNextPanel = true, _temp);
Panel.displayName = 'Panel';
exports.default = _nextConfigProvider2.default.config(Panel);
module.exports = exports['default'];