'use strict';

exports.__esModule = true;
exports.camelcase = camelcase;
exports.hyphenate = hyphenate;
/**
 * 字符串操作的方法
 * @author Fusion Team<http://next.alibaba-inc.com>
 * @create 2017/09/11
 * @exports
 * <Function> camelcase, hyphenate
 */

/**
 * 将字符串转化为坨峰式写法
 * @param  {String} str 例：-webkit-transition
 * @return {String}     例：WebkitTransition
 */
function camelcase(str) {
  if (!/-/.test(str)) {
    return str || '';
  }
  return str.toLowerCase().replace(/-([a-z])/g, function ($0, $1) {
    return $1.toUpperCase();
  });
}

/**
 * 将坨峰式字符串转化为连字符写法
 * @param  {String} str 例：WebkitTransition
 * @return {String}     例：-webkit-transition
 */
function hyphenate(str) {
  return str.replace(/([A-Z])/g, function ($0) {
    return '-' + $0.toLowerCase();
  });
}